# 模板渲染相关

用法可参考 demo/demo_template.html

SXTemplateRender 可以实现在 web 浏览器直接实时预览模板的功能

## SXTemplateType
模板类型

```
kNormalTemplate 普通／标准模板     
kDynamicTemplate 动态模板
```


## SXRenderConfig
模板渲染配置信息

#### constructor(templatePath : string) : SXRenderConfig
```
templatePath : 模板路径
```

#### isValid() : boolean
```
是否有效
```

#### getFps() : number
```
获取模板帧率
```

#### getWidth() : number
```
模板宽度 : px
```

#### getHeight() : number
```
模板高度　: px
```

#### getDuration() : number
```
获取模板时长，　单位：秒，　仅常规模板有效
```

#### getTemplateType() : SXTemplateType
```
获取模板类型
```

## SXTemplateRender
模板渲染类

#### constructor(config : SXRenderConfig, license : string, canvasId : string)
```
config  : SXRenderConfig
license : 证书
canvasId : canvas id
```

#### commit() 
```
提交修改的信息，　在　seek/draw 之前调用，　仅一次有效
```

#### seek(time : number )
```
设置播放的时间点

@param : time 时间点, 单位: 秒
```

#### draw(sync : boolean, stepForward : bool, callback : number)
```
 绘制画面

 @param async, 是否异步绘制
 @param stepForward, 是否自动前进一帧, 如果是播放时建议使用 true,
 @param callid, 回调函数 id
```

#### getDuration() : number
```
获取时长, 单位: 秒
```

#### getCurrentTime() : number
```
获取当前绘制时间, 单位: 秒
```

#### getAudioManager() : SXAudioManager
```
获取音频管理器
```

#### setReplaceableJson(json : string, adapt_video : boolean)
```
以json配置数据来设置替换数据

@param json 配置数据
@param adapt_video 是否适配视频时长，仅对动态模版有效
@return 是否设置成功，配置文件解析失败会导致设置失败
```

## SXRenderSettings
渲染配置类

#### setEnableSourceManager(enable : bool) : void
```
设置是否开启素材缓存

@param enable
```

#### setSourceManagerCacheSize(size : number) : void
```
设置缓存池大小,默认  50M

@param size 缓存池大小
```

#### setDefaultFont(path : string) : void
```
设置默认字体路径

@param path, 字体路径
```

### setFontDir(path : string) : void
```
设置字体目录路径

@param path, 字体目录路径
```