
__ATMAIN__.push(function() {

    var SXSdk = {};
    SXSdk.callbacks = {};
    SXSdk.callid = 0;
    SXSdk.listeners = {};
    SXSdk.listenerid = 0;
    SXSdk.createCallback = function(func) {
        SXSdk.callid += 1;
        SXSdk.callbacks[SXSdk.callid] = {
            isTemp: true,
            func : func
        };
        return SXSdk.callid;
    }
    SXSdk.createPersistCallback = function(func) {
        SXSdk.callid += 1;
        SXSdk.callbacks[SXSdk.callid] = {
            isTemp: false,
            func : func
        };
        return SXSdk.callid;
    }

    SXSdk.runCallback = function(_callid, code, data) {
        if (typeof(SXSdk.callbacks[_callid]) !== "undefined" ) {
            var callback = SXSdk.callbacks[_callid];
            callback['func'](code, data);

            // delete callback not global
            if (callback['isTemp']) {
                delete SXSdk.callbacks[_callid];
            }
        } else {
            console.log("current callback size " + Object.keys(SXSdk.callbacks).length + ", invalid callid " + _callid);
        }
    }

    SXSdk.removeCallback = function(_callid) {
        delete SXSdk.callbacks[_callid];
    }

    SXSdk.registerListener = function(listener) {
        SXSdk.listenerid += 1;
        var id = SXSdk.listenerid;
        SXSdk.listeners[id] = listener;
        return id;
    }

    SXSdk.getListener = function(lisid) {
        return SXSdk.listeners[lisid];
    }
    SXSdk.removeListener = function(lisid) {
        delete SXSdk.listeners[lisid];
    }

    SXSdk.formatDate = function(fmt, date) {
        let ret;
        const opt = {
            "Y+": date.getFullYear().toString(),        // 年
            "m+": (date.getMonth() + 1).toString(),     // 月
            "d+": date.getDate().toString(),            // 日
            "H+": date.getHours().toString(),           // 时
            "M+": date.getMinutes().toString(),         // 分
            "s+": date.getSeconds().toString(),          // 秒
            "S+": date.getMilliseconds().toString()     // 毫秒
        };
        for (let k in opt) {
            ret = new RegExp("(" + k + ")").exec(fmt);
            if (ret) {
                fmt = fmt.replace(ret[1], (ret[1].length == 1) ? (opt[k]) : (opt[k].padStart(ret[1].length, "0")))
            };
        };
        return fmt;
    } 

    window.SXSdk = SXSdk;
    window.SXVec2 = Module.SXVec2;
    window.SXRect = Module.SXRect;
    window.SXColor = Module.SXColor;
    window.SXAffine = Module.SXAffine;
    window.SXEffectType = Module.SXEffectType;
    window.SXEffectTimeFollowType = Module.SXEffectTimeFollowType;
    window.SXEffectTimeExtendType = Module.SXEffectTimeExtendType;
    window.SXTextAlignmentType = Module.SXTextAlignmentType;
    window.SXTextStrokeStyle = Module.SXTextStrokeStyle;
    window.SXTextDirectionType = Module.SXTextDirectionType;
    window.SXColorAdjustSettings = Module.SXColorAdjustSettings;
    window.SXSegmentPath = Module.SXSegmentPath;
    window.SXShape = Module.SXShape;
    window.SXVariant = Module.SXVariant;
    window.SXGenericEffectType = Module.SXGenericEffectType;
    window.SXCallbackType = Module.SXCallbackType;

    window.SXResource = Module.SXResource;
    window.SXResourceType = Module.SXResourceType;
    window.SXFileType = Module.SXFileType;
    window.SXVideoSequenceDelegate = Module.SXVideoSequenceDelegate;
    window.SXAudioTrack = Module.SXAudioTrack;
    window.SXAudio = Module.SXAudio;
    window.SXAudioManager = Module.SXAudioManager;
    window.SXComposite = Module.SXComposite;

    window.SXAudioPlayer = Module.SXAudioPlayer;
    window.SXEditManager = Module.SXEditManager;
    window.SXEditOptions = Module.SXEditOptions;

    window.SXTrackGroup = Module.SXTrackGroup;

    window.SXTrack = Module.SXTrack;
    window.SXMediaTrack = Module.SXMediaTrack;
    window.SXStickerTrack = Module.SXStickerTrack;
    window.SXTextTrack = Module.SXTextTrack;

    window.SXEffect = Module.SXEffect;
    window.SXFilterEffect = Module.SXFilterEffect;
    window.SXVideoEffect = Module.SXVideoEffect;
    window.SXAnimationEffect = Module.SXAnimationEffect;
    window.SXTrackAnimationEffect = Module.SXTrackAnimationEffect;
    window.SXTextAnimationEffect = Module.SXTextAnimationEffect;
    window.SXGenericEffect = Module.SXGenericEffect;


    window.SXTemplateRender = Module.SXTemplateRender;
    window.SXRenderConfig = Module.SXRenderConfig;
    window.SXRenderSettings = Module.SXRenderSettings;
    window.SXResolutionRatio = Module.SXResolutionRatio;
});